<!--

   The Contents of this file are made available subject to the terms of
   either of the following licenses

          - GNU Lesser General Public License Version 2.1
          - Sun Industry Standards Source License Version 1.1

   Sun Microsystems Inc., October, 2000

   GNU Lesser General Public License Version 2.1
   =============================================
   Copyright 2000 by Sun Microsystems, Inc.
   901 San Antonio Road, Palo Alto, CA 94303, USA

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License version 2.1, as published by the Free Software Foundation.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
   MA  02111-1307  USA


   Sun Industry Standards Source License Version 1.1
   =================================================
   The contents of this file are subject to the Sun Industry Standards
   Source License Version 1.1 (the "License"); You may not use this file
   except in compliance with the License. You may obtain a copy of the
   License at http://www.openoffice.org/license.html.

   Software provided under this License is provided on an "AS IS" basis,
   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING,
   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
   See the License for the specific provisions governing your rights and
   obligations concerning the Software.

   The Initial Developer of the Original Code is: Sun Microsystems, Inc.

   Copyright © 2002 by Sun Microsystems, Inc.

   All Rights Reserved.

   Contributor(s): _______________________________________

-->
<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:office="http://openoffice.org/2000/office"
                xmlns:style="http://openoffice.org/2000/style"
                xmlns:text="http://openoffice.org/2000/text"
                xmlns:table="http://openoffice.org/2000/table"
                xmlns:draw="http://openoffice.org/2000/drawing"
                xmlns:fo="http://www.w3.org/1999/XSL/Format"
                xmlns:xlink="http://www.w3.org/1999/xlink"
                xmlns:number="http://openoffice.org/2000/datastyle"
                xmlns:svg="http://www.w3.org/2000/svg"
                xmlns:chart="http://openoffice.org/2000/chart"
                xmlns:dr3d="http://openoffice.org/2000/dr3d"
                xmlns:math="http://www.w3.org/1998/Math/MathML"
                xmlns:form="http://openoffice.org/2000/form"
                xmlns:script="http://openoffice.org/2000/script"
                office:class="text"
                office:version="1.0"
                xmlns:dc="http://purl.org/dc/elements/1.1/"
                xmlns:meta="http://openoffice.org/2000/meta"
                xmlns:config="http://openoffice.org/2001/config"
                xmlns:help="http://openoffice.org/2000/help"
                xmlns:xt="http://www.jclark.com/xt"
                extension-element-prefixes="xt"
                xmlns:urlencoder="http://www.jclark.com/xt/java/java.net.URLEncoder"
                xmlns:sxghelper="http://www.jclark.com/xt/java/com.sun.star.xslt.helper.SxgChildTransformer"
                xmlns:xalan="http://xml.apache.org/xalan"
                xmlns:java="http://xml.apache.org/xslt/java"
                exclude-result-prefixes="java">



    <!-- ************ -->
    <!-- *** body *** -->
    <!-- ************ -->


    <xsl:template match="/*/office:body">
        <xsl:param name="collectedGlobalData"/>

        <!-- DEBUG-START: only DEBUG purpose: shows the inlined style attributes of the temporary variable -->
        <xsl:if test="$DEBUG and not($outputType = 'CSS_HEADER')">
            <xsl:element name="debug_tree_of_styles"><xsl:text>
            </xsl:text><xsl:for-each select="$collectedGlobalData/allstyles/*">
<xsl:text>                      </xsl:text><xsl:value-of select="name()"/><xsl:text> = </xsl:text><xsl:value-of select="."/><xsl:text>
            </xsl:text>
                    </xsl:for-each>
            </xsl:element>
        </xsl:if>
    <!-- DEBUG-END -->


		<!-- not using of 'apply-styles-and-content' as the content table information migth have been added to 'collectedGlobalData' variable -->
        <xsl:apply-templates select="@text:style-name | @draw:style-name | @draw:text-style-name | @table:style-name"><!-- | @presentation:style-name -->
            <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
        </xsl:apply-templates>

        <!--If the input document is a global document and embed child documents (links) the child will be transformed separately
            This is necessary as child documents do not know anything about their embedding into a global document. Chapters of childs
            always start to count by zero instead of continously numbering.
            For this, the chapter numbers of the current document (as a sequence of a global document) is dependent
            of the number of chapter of the same level in preceding documents.
            In case of multiple children, for usability reasons some linking is gonna be offered and the URLs of the content-table,
            preceding and following file have to be given for the transformation.
            -->
		<xsl:choose>
	        <xsl:when test="not($outputType = 'WML') and not($outputType = 'PALM')">
	        	<xsl:choose>
		            <xsl:when test="/*/@office:class='text-global' and /*/office:body/text:section/text:section-source/@xlink:href">
						<!-- the children will be called later with a modified 'collectedGlobalData' variable -->
		                <xsl:call-template name="transform-global-document-children">
		                    <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
		                </xsl:call-template>
		            </xsl:when>
					<xsl:otherwise>
				        <xsl:apply-templates>
				            <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
				        </xsl:apply-templates>
					</xsl:otherwise>
				</xsl:choose>
	        </xsl:when>
			<xsl:otherwise>
		        <xsl:apply-templates>
		            <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
		        </xsl:apply-templates>
			</xsl:otherwise>
		</xsl:choose>
    </xsl:template>




    <!-- deactivating default template -->
    <xsl:template match="*"/>


    <!-- allowing all matched text nodes -->
    <xsl:template match="text()">
<!-- WML         <xsl:value-of select="normalize-space(.)"/> -->
        <xsl:value-of select="."/>
    </xsl:template>



    <!-- ################### -->
    <!-- ### INLINE-TEXT ### -->
    <!-- ################### -->


    <!-- ****************** -->
    <!-- *** Whitespace *** -->
    <!-- ****************** -->


    <xsl:template match="text:s">
        <xsl:call-template name="write-whitespace">
            <xsl:with-param name="whitespaces" select="@text:c"/>
        </xsl:call-template>
    </xsl:template>


    <xsl:template name="write-whitespace">
        <xsl:param name="whitespaces"/>

        <!--write two space chars as the normal white space character will be stripped
            and the other is able to break -->
        <xsl:text>&#160; </xsl:text>

        <xsl:if test="$whitespaces >= 1">
            <xsl:call-template name="write-whitespace">
                <xsl:with-param name="whitespaces" select="$whitespaces - 1"/>
            </xsl:call-template>
        </xsl:if>
    </xsl:template>



    <!-- *************** -->
    <!-- *** Textbox *** -->
    <!-- *************** -->

    <xsl:template match="draw:text-box">
        <xsl:param name="collectedGlobalData"/>

            <xsl:choose>
                <!--+++++ CSS (CASCADING STLYE SHEET) HEADER STYLE WAY +++++-->
                <!--                or                  -->
                <!--+++++ HTML 4.0 INLINED WAY  +++++-->
                <xsl:when test="$outputType = 'CSS_HEADER' or $outputType = 'CSS_INLINED'">
                    <xsl:element name="span">
                        <xsl:if test="@fo:min-height | @svg:width">
                            <xsl:attribute name="style">
                                <xsl:choose>
                                    <xsl:when test="not(@svg:width)">
                                        <xsl:text>height: </xsl:text><xsl:value-of select="@fo:min-height"/><xsl:text>; </xsl:text>
                                    </xsl:when>
                                    <xsl:when test="not(@fo:min-height)">
                                        <xsl:text>width: </xsl:text><xsl:value-of select="@svg:width"/><xsl:text>; </xsl:text>
                                    </xsl:when>
                                    <xsl:otherwise>
                                        <xsl:text>height: </xsl:text><xsl:value-of select="@fo:min-height"/><xsl:text>; </xsl:text>
                                        <xsl:text>width: </xsl:text><xsl:value-of select="@svg:width"/><xsl:text>; </xsl:text>
                                    </xsl:otherwise>
                                </xsl:choose>
                            </xsl:attribute>
                        </xsl:if>
                        <xsl:apply-templates select="@draw:name"/>
                        <xsl:call-template name="apply-styles-and-content">
                            <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                        </xsl:call-template>
                    </xsl:element>
                </xsl:when>
                <!-- 2DO prove best usage for PALM -->
                <!--+++++ PALM 3.2 SUBSET INLINED WAY  +++++-->
                <xsl:when test="$outputType = 'PALM'">
                    <xsl:element name="span">
                        <xsl:call-template name="apply-styles-and-content">
                            <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                        </xsl:call-template>
                    </xsl:element>
                </xsl:when>
                <!-- 2DO prove best usage for WML -->
                <!--+++++ WML / WAP  +++++-->
                <xsl:otherwise>
                    <!-- no nested p tags in wml1.1 allowed -->
                    <xsl:choose>
                        <xsl:when test="ancestor::*[contains($wap-paragraph-elements, name())]">
                            <xsl:call-template name="apply-styles-and-content">
                                <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                            </xsl:call-template>
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:element name="p">
                                <xsl:call-template name="apply-styles-and-content">
                                    <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                                </xsl:call-template>
                             </xsl:element>
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:otherwise>
            </xsl:choose>
    </xsl:template>

    <!-- ID / NAME of text-box -->
    <xsl:template match="@draw:name">

        <xsl:attribute name="id">
            <xsl:value-of select="."/>
        </xsl:attribute>
    </xsl:template>



    <!-- ****************** -->
    <!-- *** Paragraphs *** -->
    <!-- ****************** -->

    <xsl:template match="text:p | draw:page">
        <xsl:param name="collectedGlobalData"/>

            <xsl:choose>
                <!--+++++ CSS (CASCADING STLYE SHEET) HEADER STYLE WAY +++++-->
                <xsl:when test="$outputType = 'CSS_HEADER'">
                    <xsl:element name="p">
                        <xsl:call-template name="apply-styles-and-content">
                            <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                        </xsl:call-template>
                    </xsl:element>
                </xsl:when>

                <!--+++++ HTML 4.0 INLINED WAY  +++++-->
                <xsl:when test="$outputType = 'CSS_INLINED'">
                    <xsl:element name="p">
                        <xsl:call-template name="apply-styles-and-content">
                            <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                        </xsl:call-template>
                    </xsl:element>
                </xsl:when>
                <!--+++++ PALM 3.2 SUBSET INLINED WAY  +++++-->
                <xsl:when test="$outputType = 'PALM'">
                    <xsl:choose>
                        <!-- in palm paragraphs children of text:list-items are better shown without 'p' tag-->
                        <xsl:when test="name(parent::*) = 'text:list-item'">
                            <xsl:call-template name="apply-styles-and-content">
                                <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                            </xsl:call-template>
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:element name="p">
                                <xsl:call-template name="apply-styles-and-content">
                                    <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                                </xsl:call-template>
                            </xsl:element>
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:when>
                <!--+++++ WML / WAP  +++++-->
                <xsl:otherwise>
                    <!-- no nested p tags in wml1.1 allowed -->
                    <xsl:choose>
                        <xsl:when test="ancestor::*[contains($wap-paragraph-elements, name())]">
                            <xsl:call-template name="apply-styles-and-content">
                                <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                            </xsl:call-template>
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:element name="p">
                                <xsl:call-template name="apply-styles-and-content">
                                    <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                                </xsl:call-template>
                             </xsl:element>
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:otherwise>
            </xsl:choose>
    </xsl:template>



    <!-- ***************** -->
    <!-- *** Text Span *** -->
    <!-- ***************** -->

    <xsl:template match="text:span">
        <xsl:param name="collectedGlobalData"/>

        <xsl:choose>
            <!--+++++ CSS (CASCADING STLYE SHEET) HEADER STYLE WAY +++++-->
            <xsl:when test="$outputType = 'CSS_HEADER'">
                <xsl:element name="span">
                    <xsl:call-template name="apply-styles-and-content">
                        <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                    </xsl:call-template>
                </xsl:element>
            </xsl:when>

            <!--+++++ HTML 4.0 INLINED WAY  +++++-->
            <xsl:when test="$outputType = 'CSS_INLINED'">
                <xsl:element name="span">
                    <xsl:call-template name="apply-styles-and-content">
                        <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                    </xsl:call-template>
                </xsl:element>
            </xsl:when>
            <!--+++++ PALM 3.2 SUBSET INLINED WAY  +++++-->
            <xsl:when test="$outputType = 'PALM'">
                <xsl:call-template name="apply-styles-and-content">
                    <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                </xsl:call-template>
            </xsl:when>
            <!--+++++ WML / WAP  +++++-->
            <xsl:otherwise>
                <!-- no nested p tags in wml1.1 allowed -->
                <xsl:choose>
                    <xsl:when test="ancestor::*[contains($wap-paragraph-elements, name())]">
                        <xsl:call-template name="apply-styles-and-content">
                            <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                        </xsl:call-template>
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:element name="p">
                            <xsl:call-template name="apply-styles-and-content">
                                <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                            </xsl:call-template>
                        </xsl:element>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>



    <!-- **************** -->
    <!-- *** Headings *** -->
    <!-- **************** -->

    <xsl:template match="text:h">
        <xsl:param name="collectedGlobalData"/>

        <xsl:choose>
            <xsl:when test="$disableLinkedTableOfContent or $disableJava or not($outputType = 'CSS_HEADER')">
            <!-- The URL linking of an table-of-content is due to a bug (cmp. bug id# 102311) not mapped as URL in the XML.
                 Linking of the table-of-content can therefore only be archieved by a work-around in HTML -->
                <xsl:call-template name="create-header">
                    <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                </xsl:call-template>
           </xsl:when>
           <xsl:otherwise>

                <!-- Usability feature, a link to the Content talbe above all level 1 header -->
                <xsl:if test="@text:level = 1">
                    <xsl:element name="center">
                        <xsl:element name="small">
                            <xsl:text>[ </xsl:text>
                            <!--<xsl:for-each select="$collectedGlobalData">-->
                                <xsl:element name="a">
                                    <xsl:attribute name="href">
                                        <xsl:value-of select="$contentTableURL"/>
                                    </xsl:attribute>
                                    <xsl:text>Content Table</xsl:text>
                                </xsl:element>
                            <!--    <xsl:text> | </xsl:text>
                            </xsl:for-each>-->
                            <xsl:text> ]</xsl:text>
                        </xsl:element>
                    </xsl:element>
                </xsl:if>
                <!--
                Currently the link used in the Office XML (e.g. in the content table as '#7.Some%20Example%20Headline%7Outline')
                is not a valid URL (cmp. bug id# 102311). No file destination is specified nor exist any anchor element for these
                links in the Office XML.
                Here we are creating an anchor with the space normalized text of this header as potential jump address of the content table -->
                <xsl:element name="a">
                    <xsl:attribute name="name">
                        <xsl:variable name="normalizedHeader" select="normalize-space(text())"/>

                        <!-- in this case xlink:href will be ignored and own link will be created
                             (cp. parameter discription 'disableLinkedTableOfContent') -->
                            <xsl:call-template name="encode-string">
                                <xsl:with-param name="textToBeEncoded" select="$normalizedHeader"/>
                            </xsl:call-template>
                    </xsl:attribute>
                </xsl:element>

                <!-- no embedding the orginal header, as an explicit anchor might be already set -->
                <xsl:call-template name="create-header">
                    <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                </xsl:call-template>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>


    <!-- default matching for header elements -->
    <xsl:template name="create-header">
        <xsl:param name="collectedGlobalData"/>

        <xsl:choose>
            <!--+++++ CSS (CASCADING STLYE SHEET) HEADER STYLE WAY +++++-->
            <xsl:when test="$outputType = 'CSS_HEADER'">

                <xsl:variable name="headertyp" select="concat('h', @text:level)"/>
                <xsl:element name="{$headertyp}">

                    <!-- outline style 'text:min-label-width' is interpreted as a CSS 'margin-left' attribute -->
                    <xsl:variable name="min-label" select="$office:styles/text:outline-style/text:outline-level-style[@text:level = current()/@text:level]/style:properties/@text:min-label-width"/>
                    <xsl:if test="$min-label">
                        <xsl:attribute name="style"><xsl:text>margin-left:</xsl:text><xsl:value-of select="$min-label"/><xsl:text>;</xsl:text></xsl:attribute>
                    </xsl:if>

                    <xsl:attribute name="class"><xsl:value-of select="translate(@text:style-name, '. %()/\', '')"/></xsl:attribute>

                    <!-- writing out a chapter number if desired (noticable when a corresponding 'text:outline-style' exist -->
                    <xsl:if test="$office:styles/text:outline-style/text:outline-level-style[@text:level = current()/@text:level]/@text:style-name">
                        <!-- the chapter number is the sum of 'text:start-value' and preceding siblings of 'text:h' with the same 'text:level',
                             furthermore when the current document is referenced by a global document - as part of a whole sequence of documents -,
                             the chapter no. is dependent of the amount of started headers in preceding documents.
                             If the 'text:start-value is not set the default value of '1' has to be taken. -->
                        <xsl:variable name="startValue" select="$office:styles/text:outline-style/text:outline-level-style[@text:level = current()/@text:level]/@text:start-value"/>
                        <xsl:choose>
                            <xsl:when test="$startValue">
                                <xsl:choose>
                                    <xsl:when test="@text:level='1'">
                                        <xsl:value-of select="count(preceding-sibling::text:h[@text:level = current()/@text:level])
                                                    + $precedingChapterLevel1
                                                    + $startValue"/>
                                    </xsl:when>
                                    <xsl:when test="@text:level='2'">
                                        <xsl:value-of select="count(preceding-sibling::text:h[@text:level = current()/@text:level])
                                                    + $precedingChapterLevel2
                                                    + $startValue"/>
                                    </xsl:when>
                                    <xsl:when test="@text:level='3'">
                                        <xsl:value-of select="count(preceding-sibling::text:h[@text:level = current()/@text:level])
                                                    + $precedingChapterLevel3
                                                    + $startValue"/>
                                    </xsl:when>
                                    <xsl:when test="@text:level='4'">
                                        <xsl:value-of select="count(preceding-sibling::text:h[@text:level = current()/@text:level])
                                                    + $precedingChapterLevel4
                                                    + $startValue"/>
                                    </xsl:when>
                                    <xsl:when test="@text:level='5'">
                                        <xsl:value-of select="count(preceding-sibling::text:h[@text:level = current()/@text:level])
                                                    + $precedingChapterLevel5
                                                    + $startValue"/>
                                    </xsl:when>
                                    <xsl:when test="@text:level='6'">
                                        <xsl:value-of select="count(preceding-sibling::text:h[@text:level = current()/@text:level])
                                                    + $precedingChapterLevel6
                                                    + $startValue"/>
                                    </xsl:when>
                                    <xsl:when test="@text:level='7'">
                                        <xsl:value-of select="count(preceding-sibling::text:h[@text:level = current()/@text:level])
                                                    + $precedingChapterLevel7
                                                    + $startValue"/>
                                    </xsl:when>
                                    <xsl:when test="@text:level='8'">
                                        <xsl:value-of select="count(preceding-sibling::text:h[@text:level = current()/@text:level])
                                                    + $precedingChapterLevel8
                                                    + $startValue"/>
                                    </xsl:when>
                                    <xsl:when test="@text:level='9'">
                                        <xsl:value-of select="count(preceding-sibling::text:h[@text:level = current()/@text:level])
                                                    + $precedingChapterLevel9
                                                    + $startValue"/>
                                    </xsl:when>
                                    <xsl:when test="@text:level='10'">
                                        <xsl:value-of select="count(preceding-sibling::text:h[@text:level = current()/@text:level])
                                                    + $precedingChapterLevel10
                                                    + $startValue"/>
                                    </xsl:when>
                                </xsl:choose>
                            </xsl:when>
                            <xsl:otherwise>
                                <xsl:value-of select="count(preceding-sibling::text:h[@text:level = current()/@text:level])
                                            + $precedingChapterLevel1
                                            + 1"/>
                            </xsl:otherwise>
                        </xsl:choose>
                        <xsl:text> &#160; &#160;</xsl:text>
                    </xsl:if>
                    <xsl:apply-templates>
                        <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                    </xsl:apply-templates>

                </xsl:element>
            </xsl:when>


            <!--+++++ HTML 4.0 INLINED WAY  +++++-->
            <xsl:when test="$outputType = 'CSS_INLINED'">
                <xsl:variable name="headertyp" select="concat('h', @text:level)"/>
                <xsl:element name="{$headertyp}">

                    <xsl:apply-templates select="@text:style-name">
                        <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                    </xsl:apply-templates>

                    <!-- writing out a chapter number if desired (noticable when a corresponding 'text:outline-style' exist -->
                    <xsl:if test="$office:styles/text:outline-style/text:outline-level-style[@text:level = current()/@text:level]/@text:style-name">

                        <!-- the chapter number is the sum of 'text:start-value' and preceding siblings of 'text:h' with the same 'text:level' -->
                        <xsl:value-of select="count(preceding-sibling::text:h[@text:level = current()/@text:level])
                                            + $office:styles/text:outline-style/text:outline-level-style[@text:level = current()/@text:level]/@text:start-value"/>
                        <xsl:text> &#160; &#160;</xsl:text>
                    </xsl:if>

                </xsl:element>
            </xsl:when>

            <!-- 2DO: add Chapter No. for PALM and WML <-> problem nested apply-templates -->

            <!--+++++ PALM 3.2 SUBSET INLINED WAY  +++++-->
            <xsl:when test="$outputType = 'PALM'">
                <xsl:variable name="headertyp" select="concat('h', @text:level)"/>
                <xsl:element name="{$headertyp}">


                    <!-- All children content have to be nested in the styles (e.g. <i><b>ANY CONTENT</b></i>)
                         for this xsl:apply-templates will be called later / implicit -->
                    <xsl:call-template name="create-attribute-ALIGN">
                        <!-- getting the css styles for the style name (mapped by style-mapping.xsl) -->
                        <xsl:with-param name="styleProperties" select="$collectedGlobalData/allstyles/*[name()=current()/@text:style-name]"/>
                    </xsl:call-template>
                </xsl:element>
            </xsl:when>

            <!--+++++ WML / WAP  +++++-->
            <xsl:otherwise>
                <!-- no nested p tags in wml1.1 allowed -->
                <xsl:choose>
                    <xsl:when test="ancestor::*[contains($wap-paragraph-elements, name())]">
                        <!-- since no header styles exist, an emphasis is used -->
                        <xsl:element name="em">

                            <!-- writing out a chapter number if desired (noticable when a corresponding 'text:outline-style' exist -->
                            <xsl:if test="$office:styles/text:outline-style/text:outline-level-style[@text:level = current()/@text:level]/@text:style-name">

                                <!-- the chapter number is the sum of 'text:start-value' and preceding siblings of 'text:h' with the same 'text:level' -->
                                <xsl:value-of select="count(preceding-sibling::text:h[@text:level = current()/@text:level])
                                                    + $office:styles/text:outline-style/text:outline-level-style[@text:level = current()/@text:level]/@text:start-value"/>
                                <xsl:text> &#160; &#160;</xsl:text>
                            </xsl:if>

                            <xsl:apply-templates select="@text:style-name">
                                <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                            </xsl:apply-templates>

                        </xsl:element>
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:element name="p">
                            <!-- since no header styles exist, an emphasis is used -->
                            <xsl:element name="em">
                                <xsl:call-template name="apply-styles-and-content">
                                    <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                                </xsl:call-template>
                            </xsl:element>
                        </xsl:element>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>



    <!-- ************* -->
    <!-- *** Link  *** -->
    <!-- ************* -->

    <xsl:template match="text:a | draw:a">
        <xsl:param name="collectedGlobalData"/>


        <!-- For anchors in content-headers a bug exists (cp. bug id# 102311) and they have to be worked out separately.
        Currently the link used in the content-table of an Office XML (e.g. in the content table as '#7.Some%20Example%20Headline%7Outline')
        is not a valid URL (cp. bug id# 102311). No file destination is specified nor exist any anchor element for these
        links in the Office XML, nor is the chapter no. known in the linked files.
        A workaround for this transformation therefore had to be made. This time-consuming mechanism is disabled by default and
        can be activated by a parameter (i.e. 'disableLinkedTableOfContent'). A creation of an anchor is made for each header element.
        All header titles gonna be encoding to be usable in a relative URL. -->

        <xsl:choose>
            <xsl:when test="$disableLinkedTableOfContent or $disableJava">
                <xsl:call-template name="create-common-link">
                    <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                </xsl:call-template>
           </xsl:when>
            <xsl:otherwise>
                <!-- test if the link is part of an content-table -->
                <xsl:choose>
                    <xsl:when test="ancestor::text:index-body">
                        <!-- test if the the global data for content table is already constructed -->
                        <xsl:choose>
                            <xsl:when test="$collectedGlobalData/contentTable">
                                <xsl:call-template name="create-content-table-link">
                                    <xsl:with-param name="collectedGlobalData"       select="$collectedGlobalData"/>
                                </xsl:call-template>
                            </xsl:when>
                            <xsl:otherwise>
                                <!-- The necessary auxiliary variable hasn't build yet.
                                This variable gonna store all headers (possible anchor positions) and the URL of their files -->
                                <xsl:variable name="documentDependencies-RTF">
                                    <xsl:call-template name="add-content-table-global-data">
                                        <xsl:with-param name="collectedGlobalData"       select="$collectedGlobalData"/>
                                    </xsl:call-template>
                                </xsl:variable>

                                <xsl:choose>
                                    <xsl:when test="function-available('xt:node-set')">
                                        <xsl:call-template name="create-content-table-link">
                                            <xsl:with-param name="collectedGlobalData"       select="xt:node-set($documentDependencies-RTF)"/>
                                        </xsl:call-template>
                                    </xsl:when>
                                    <xsl:when test="function-available('xalan:nodeset')">
                                        <xsl:call-template name="create-content-table-link">
                                            <xsl:with-param name="collectedGlobalData"       select="xalan:nodeset($documentDependencies-RTF)"/>
                                        </xsl:call-template>
                                    </xsl:when>
                                </xsl:choose>

                            </xsl:otherwise>
                        </xsl:choose>
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:call-template name="create-common-link">
                            <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                        </xsl:call-template>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>



    <xsl:template name="create-common-link">
        <xsl:param name="collectedGlobalData"/>

        <xsl:choose>
            <xsl:when test="not($outputType = 'WML')">
                <xsl:element name="a">
                    <xsl:attribute name="href"><xsl:value-of select="@xlink:href"/></xsl:attribute>
                    <!--<xsl:attribute name="class">ContentLink</xsl:attribute>-->
                    <xsl:call-template name="apply-styles-and-content">
                        <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                    </xsl:call-template>
                </xsl:element>
            </xsl:when>
            <xsl:otherwise>
                <!-- no nested p tags in wml1.1 allowed -->
                <xsl:choose>
                    <xsl:when test="ancestor::*[contains($wap-paragraph-elements, name())]">
                        <xsl:element name="a">
                            <xsl:attribute name="href"><xsl:value-of select="@xlink:href"/></xsl:attribute>
                            <xsl:apply-templates select="descendant::text()"/>
                        </xsl:element>
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:element name="p">
                            <xsl:element name="a">
                                <xsl:attribute name="href"><xsl:value-of select="@xlink:href"/></xsl:attribute>
                                <xsl:apply-templates select="descendant::text()"/>
                            </xsl:element>
                        </xsl:element>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>

     <xsl:template name="add-content-table-global-data">
        <xsl:param name="collectedGlobalData"/>


        // all heading (potential chapters) of the input file of the transformation
        <xsl:element name="contentTable">
            <xsl:attribute name="contentTableURL">
                <xsl:value-of select="$contentTableURL"/>
            </xsl:attribute>
<!-- counting of heading begins after the global document
            <xsl:element name="fileName">
                <xsl:attribute name="fileURL">.</xsl:attribute>
                <xsl:for-each select="/*/office:body/descendant::text:h">
                    <xsl:element name="heading">
                        <xsl:attribute name="level"><xsl:value-of select="@text:level"/></xsl:attribute>
                        <xsl:attribute name="title"><xsl:value-of select="normalize-space(descendant::text())"/></xsl:attribute>
                    </xsl:element>
                </xsl:for-each>
            </xsl:element>
-->
            // all heading (potential chapters) linked from a current global document input file
            <xsl:for-each select="/*/office:body/text:section">
                <xsl:element name="fileName">
                    <xsl:attribute name="fileURL"><xsl:value-of select="text:section-source/@xlink:href"/></xsl:attribute>
                    <xsl:variable name="fileURL" select="text:section-source/@xlink:href"/>
                    <xsl:choose>
                    	<!-- if absolute URL or absolute DOS PATH or absolute Unix path -->
						<xsl:when test="contains($fileURL,'//') or (substring($fileURL,2,1) = ':') or starts-with($fileURL, '/')">
                            <xsl:call-template name="collectExternalFileHeadingsNames">
                            	<!-- NO absolute source path will be added as prefix -->
                                <xsl:with-param name="fileURL" select="document($fileURL)"/>
                            </xsl:call-template>
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:call-template name="collectExternalFileHeadingsNames">
                            	<!-- the absolute source path will be added as prefix -->
                                <xsl:with-param name="fileURL" select="document(concat($absoluteSourceDirRef,'/',$fileURL))"/>
                            </xsl:call-template>
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:element>
            </xsl:for-each>
        </xsl:element>

        // adding the already exisiting global data environment
        <xsl:copy-of select="$collectedGlobalData"/>
    </xsl:template>


    <xsl:template name="create-content-table-link">
        <xsl:param name="collectedGlobalData"/>

        <xsl:choose>
            <xsl:when test="not($outputType = 'WML')">
                <xsl:element name="a">
                    <xsl:attribute name="href">
                        <xsl:choose>
                            <xsl:when test="starts-with(@xlink:href, '#')">
                            <!-- in this case xlink:href will be ignored and own link will be created
                                 (cp. parameter discription 'disableLinkedTableOfContent') -->

                                <xsl:variable name="currentTitle" select="normalize-space(text())"/>
                                <xsl:variable name="encodedLinkName">
                                    <xsl:call-template name="encode-string">
                                        <xsl:with-param name="textToBeEncoded" select="$currentTitle"/>
                                    </xsl:call-template>
                                </xsl:variable>
                               <xsl:variable name="fileUrlOfChapter" select="$collectedGlobalData/contentTable/fileName[heading/@title=$currentTitle]/@fileURL"/>
                               <xsl:value-of select="concat(substring-before($fileUrlOfChapter,'.xml'),'.htm#',$encodedLinkName)"/>
                          </xsl:when>
                          <xsl:otherwise>
                                <xsl:call-template name="create-common-link">
                                    <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                                </xsl:call-template>
                            </xsl:otherwise>
                        </xsl:choose>
                    </xsl:attribute>

                    <xsl:call-template name="apply-styles-and-content">
                        <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                    </xsl:call-template>
                </xsl:element>
            </xsl:when>
            <xsl:otherwise>
                <!-- 2DO: currently no WML support

                <!~~ no nested p tags in wml1.1 allowed ~~>
                <xsl:choose>
                    <xsl:when test="ancestor::*[contains($wap-paragraph-elements, name())]">
                        <xsl:element name="a">
                            <xsl:attribute name="href"><xsl:value-of select="@xlink:href"/></xsl:attribute>
                            <xsl:apply-templates select="descendant::text()"/>
                        </xsl:element>
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:element name="p">
                            <xsl:element name="a">
                                <xsl:attribute name="href"><xsl:value-of select="@xlink:href"/></xsl:attribute>
                                <xsl:apply-templates select="descendant::text()"/>
                            </xsl:element>
                        </xsl:element>
                    </xsl:otherwise>
                </xsl:choose>  -->
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>



    <xsl:template name="encode-string">
        <xsl:param name="encoding" select="'UTF-8'"/>
        <xsl:param name="textToBeEncoded"/>
        <xsl:choose>
            <xsl:when test="function-available('urlencoder:encode')">
                <xsl:value-of select="urlencoder:encode($textToBeEncoded,$encoding)"/>
            </xsl:when>
            <xsl:when test="function-available('java:java.net.URLEncoder.encode')">
                <xsl:value-of select="java:java.net.URLEncoder.encode(string($textToBeEncoded),string($encoding))"/>
            </xsl:when>
        </xsl:choose>
    </xsl:template>


    <xsl:template name="collectExternalFileHeadingsNames">
         <xsl:param name="fileURL"/>

        <!-- office:document as root as FLAT XML is being used here -->
        <xsl:for-each select="$fileURL/*/office:body/descendant::text:h">
            <xsl:element name="heading">
                <xsl:attribute name="title"><xsl:value-of select="normalize-space(descendant::text())"/></xsl:attribute>
                <xsl:attribute name="level"><xsl:value-of select="@text:level"/></xsl:attribute>
            </xsl:element>
        </xsl:for-each>
    </xsl:template>


    <xsl:template match="text:reference-ref">
        <xsl:param name="collectedGlobalData"/>

        <!-- Java is needed as we have to encode the relative links (bug#102311) -->
        <xsl:if test="not($disableJava)">
            <xsl:element name="a">
                <xsl:attribute name="href">
                    <xsl:text>#</xsl:text>
                    <xsl:call-template name="encode-string">
                         <xsl:with-param name="textToBeEncoded" select="normalize-space(@text:ref-name)"/>
                    </xsl:call-template>
                </xsl:attribute>

                <xsl:apply-templates>
                    <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                </xsl:apply-templates>

            </xsl:element>
       </xsl:if>
   </xsl:template>


    <xsl:template match="text:reference-mark">
        <xsl:param name="collectedGlobalData"/>

        <!-- Java is needed as we have to encode the relative links (bug#102311) -->
        <xsl:if test="not($disableJava)">
            <xsl:element name="a">
                <xsl:attribute name="name">
                    <xsl:call-template name="encode-string">
                        <xsl:with-param name="textToBeEncoded" select="normalize-space(@text:name)"/>
                    </xsl:call-template>
                </xsl:attribute>

                <xsl:apply-templates>
                    <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                </xsl:apply-templates>

            </xsl:element>
       </xsl:if>
   </xsl:template>

    <xsl:template match="text:reference-mark-start">
        <xsl:param name="collectedGlobalData"/>

        <!-- Java is needed as we have to encode the relative links (bug#102311) -->
        <xsl:if test="not($disableJava)">
            <xsl:element name="a">
                <xsl:attribute name="name">
                    <xsl:call-template name="encode-string">
                        <xsl:with-param name="textToBeEncoded" select="normalize-space(@text:name)"/>
                    </xsl:call-template>
                </xsl:attribute>

                <xsl:variable name="endOfReference">
                    <xsl:for-each select="text:reference-mark-end[@name=current()/@text:name]">
                        <xsl:value-of select="position()"/>
                    </xsl:for-each>
                </xsl:variable>

                <xsl:for-each select="following-sibling::*[position() &lt; $endOfReference]">
                    <xsl:apply-templates>
                        <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                    </xsl:apply-templates>
                </xsl:for-each>
            </xsl:element>
       </xsl:if>
    </xsl:template>



    <!-- ******************* -->
    <!-- *** Image Link  *** -->
    <!-- ******************* -->

    <xsl:template match="draw:image">
        <xsl:param name="collectedGlobalData"/>

        <!-- NO IMAGES SUPPLIED FOR WAP OR PALM -->
        <xsl:if test="$outputType = 'CSS_HEADER' or $outputType = 'CSS_INLINED'">

            <xsl:element name="img">
                <xsl:if test="@svg:width">
                    <xsl:attribute name="width">
                        <xsl:call-template name="convert2pixel">
                            <xsl:with-param name="value" select="@svg:width"/>
                        </xsl:call-template>
                    </xsl:attribute>
                </xsl:if>
                <xsl:if test="@svg:height">
                    <xsl:attribute name="height">
                        <xsl:call-template name="convert2pixel">
                            <xsl:with-param name="value" select="@svg:height"/>
                        </xsl:call-template>
                    </xsl:attribute>
                </xsl:if>
                <xsl:choose>
                     <!-- for images jared in open office document -->
                    <xsl:when test="contains(@xlink:href, '#Pictures/')">
                        <!-- creating an absolute http URL to the packed image file -->
                        <xsl:attribute name="src"><xsl:value-of select="concat($jaredRootURL, '/Pictures/', substring-after(@xlink:href, '#Pictures/'), $optionalURLSuffix)"/></xsl:attribute>
                    </xsl:when>
<!--                    Due to a XT bug no DOS ':' before DRIVE letter is allowed, it would result in a unkown protoco exception, but a file URL for a DOS
						path needs the DRIVE letter, therefore all relative URLs remain relativ

					<xsl:when test="contains(@xlink:href,'//') or (substring(@xlink:href,2,1) = ':') or starts-with(@xlink:href, '/')">
                        <xsl:attribute name="src"><xsl:value-of select="@xlink:href"/></xsl:attribute>
                    </xsl:when>
                    <xsl:otherwise>
                        <!~~ creating a absolute path/URL for the referenced resource ~~>
                        <xsl:attribute name="src"><xsl:value-of select="concat($absoluteSourceDirRef, @xlink:href, $optionalURLSuffix)"/></xsl:attribute>
                    </xsl:otherwise>
-->
					<xsl:otherwise>
                        <xsl:attribute name="src"><xsl:value-of select="@xlink:href"/></xsl:attribute>
                    </xsl:otherwise>
                </xsl:choose>

                <xsl:call-template name="apply-styles-and-content">
                    <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                </xsl:call-template>
            </xsl:element>
            <!-- adding a line break to make the presentation more even with the OOo view -->
            <xsl:element name="br"/>
        </xsl:if>
    </xsl:template>



    <!-- ******************** -->
    <!-- *** ordered list *** -->
    <!-- ******************** -->

    <xsl:template match="text:ordered-list">
        <xsl:param name="collectedGlobalData"/>

            <xsl:choose>
                <!--+++++ CSS (CASCADING STLYE SHEET) HEADER STYLE WAY +++++-->
                <xsl:when test="$outputType = 'CSS_HEADER'">
                    <xsl:element name="ol">
                        <xsl:call-template name="apply-styles-and-content">
                            <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                        </xsl:call-template>
                    </xsl:element>
                </xsl:when>
                <!--+++++ HTML 4.0 INLINED WAY  +++++-->
                <xsl:when test="$outputType = 'CSS_INLINED'">
                    <xsl:element name="ol">
                        <xsl:call-template name="apply-styles-and-content">
                            <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                        </xsl:call-template>
                    </xsl:element>
                </xsl:when>
                <!--+++++ PALM 3.2 SUBSET AND WAP INLINED WAY  +++++-->
                <xsl:when test="$outputType = 'PALM'">
                    <xsl:element name="ol">
                        <xsl:call-template name="apply-styles-and-content">
                            <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                        </xsl:call-template>
                    </xsl:element>
                </xsl:when>
                <!--+++++ WML / WAP  +++++-->
                <xsl:otherwise>
                    <xsl:choose>
                        <!-- simulating content break of capsulated list elements -->
                        <xsl:when test="ancestor::text:list-item">
                            <xsl:choose>
                                <xsl:when test="ancestor::*[contains($wap-paragraph-elements, name())]">
                                    <!-- simulating content break of capsulated list elements -->
                                    <xsl:element name="br"></xsl:element>
                                    <xsl:call-template name="apply-styles-and-content">
                                        <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                                    </xsl:call-template>
                                </xsl:when>
                                <xsl:otherwise>
                                    <xsl:element name="p">
                                        <!-- simulating content break of capsulated list elements -->
                                        <xsl:element name="br"></xsl:element>
                                        <xsl:call-template name="apply-styles-and-content">
                                            <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                                        </xsl:call-template>
                                    </xsl:element>
                                </xsl:otherwise>
                            </xsl:choose>
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:call-template name="apply-styles-and-content">
                                <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                            </xsl:call-template>
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:otherwise>
            </xsl:choose>
    </xsl:template>



    <!-- ********************** -->
    <!-- *** unordered list *** -->
    <!-- ********************** -->

    <xsl:template match="text:unordered-list">
        <xsl:param name="collectedGlobalData"/>

        <xsl:choose>
            <!--+++++ CSS (CASCADING STLYE SHEET) HEADER STYLE WAY +++++-->
            <xsl:when test="$outputType = 'CSS_HEADER'">
                <xsl:element name="ul">
                    <xsl:call-template name="apply-styles-and-content">
                        <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                    </xsl:call-template>
                </xsl:element>
            </xsl:when>

            <!--+++++ HTML 4.0 INLINED WAY  +++++-->
            <xsl:when test="$outputType = 'CSS_INLINED'">
                <xsl:element name="ul">
                    <xsl:call-template name="apply-styles-and-content">
                        <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                    </xsl:call-template>
                </xsl:element>
            </xsl:when>

            <!--+++++ PALM 3.2 SUBSET AND WAP INLINED WAY  +++++-->
            <xsl:when test="$outputType = 'PALM'">
                <xsl:element name="ul">
                    <xsl:call-template name="apply-styles-and-content">
                        <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                    </xsl:call-template>
                </xsl:element>
            </xsl:when>

            <!--+++++ WML / WAP  +++++-->
            <xsl:otherwise>
                <xsl:choose>
                    <!-- simulating content break of capsulated list elements -->
                    <xsl:when test="ancestor::text:list-item">
                        <xsl:choose>
                            <xsl:when test="ancestor::*[contains($wap-paragraph-elements, name())]">
                                <!-- simulating content break of capsulated list elements -->
                                <xsl:element name="br"></xsl:element>
                                <xsl:call-template name="apply-styles-and-content">
                                    <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                                </xsl:call-template>
                            </xsl:when>
                            <xsl:otherwise>
                                <xsl:element name="p">
                                    <!-- simulating content break of capsulated list elements -->
                                    <xsl:element name="br"></xsl:element>
                                    <xsl:call-template name="apply-styles-and-content">
                                        <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                                    </xsl:call-template>
                                </xsl:element>
                            </xsl:otherwise>
                        </xsl:choose>
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:call-template name="apply-styles-and-content">
                            <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                        </xsl:call-template>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>



    <!-- ****************** -->
    <!-- *** list item  *** -->
    <!-- ****************** -->

    <xsl:template match="text:list-item">
        <xsl:param name="collectedGlobalData"/>

        <xsl:choose>
            <!--+++++ CSS (CASCADING STLYE SHEET) HEADER STYLE WAY +++++-->
            <xsl:when test="$outputType = 'CSS_HEADER'">
                <xsl:element name="li">
                    <xsl:call-template name="apply-styles-and-content">
                        <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                    </xsl:call-template>
                </xsl:element>
            </xsl:when>

            <!--+++++ HTML 4.0 INLINED WAY  +++++-->
            <xsl:when test="$outputType = 'CSS_INLINED'">
                <xsl:element name="li">
                    <xsl:call-template name="apply-styles-and-content">
                        <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                    </xsl:call-template>
                </xsl:element>
            </xsl:when>

            <!--+++++ PALM 3.2 SUBSET AND WAP INLINED WAY  +++++-->
            <xsl:when test="$outputType = 'PALM'">
                <xsl:element name="li">
                    <xsl:call-template name="apply-styles-and-content">
                        <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                    </xsl:call-template>
                </xsl:element>
            </xsl:when>

            <!--+++++ WML / WAP  +++++-->
            <xsl:otherwise>
                <xsl:choose>
                    <xsl:when test="ancestor::*[contains($wap-paragraph-elements, name())]">
                        <!-- simulating list elements -->
                        <xsl:for-each select="ancestor::text:list-item">*</xsl:for-each>
                        <xsl:text>* </xsl:text>
                        <xsl:call-template name="apply-styles-and-content">
                            <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                        </xsl:call-template>
                        <!-- list item break simulation (not in a table)-->
                        <xsl:if test="not(ancestor::table:table-cell) or following-sibling::text:list-item">
                            <xsl:element name="br"/>
                        </xsl:if>
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:element name="p">
                            <!-- simulating list elements -->
                            <xsl:for-each select="ancestor::text:list-item">*</xsl:for-each>
                            <xsl:text>* </xsl:text>
                            <xsl:call-template name="apply-styles-and-content">
                                <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                            </xsl:call-template>
                            <!-- list item break simulation (not in a table)-->
                            <xsl:if test="not(ancestor::table:table-cell) or following-sibling::text:list-item">
                                <xsl:element name="br"/>
                            </xsl:if>
                        </xsl:element>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>



    <!-- ********************************************** -->
    <!-- *** Text Section (contains: draw:text-box) *** -->
    <!-- ********************************************** -->

    <xsl:template match="text:section">
        <xsl:param name="collectedGlobalData"/>

        <xsl:if test="not(contains(@text:display, 'none'))">
            <xsl:choose>
                <!--+++++ CSS (CASCADING STLYE SHEET) HEADER STYLE WAY +++++-->
                <xsl:when test="$outputType = 'CSS_HEADER'">
                    <xsl:element name="span">
                        <xsl:call-template name="apply-styles-and-content">
                            <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                        </xsl:call-template>
                    </xsl:element>
                </xsl:when>
                <!--+++++ HTML 4.0 INLINED WAY  +++++-->
                <xsl:when test="$outputType = 'CSS_INLINED'">
                    <xsl:element name="span">
                        <xsl:call-template name="apply-styles-and-content">
                            <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                        </xsl:call-template>
                    </xsl:element>
                </xsl:when>
                <!--+++++ PALM 3.2 SUBSET INLINED WAY  +++++-->
                <xsl:when test="$outputType = 'PALM'">
                    <xsl:choose>
                        <xsl:when test="name(parent::*) = 'text:list-item'">
                                        <xsl:call-template name="apply-styles-and-content">
                                            <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                                        </xsl:call-template>
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:element name="p">
                                <xsl:call-template name="apply-styles-and-content">
                                    <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                                </xsl:call-template>
                            </xsl:element>
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:when>
                <!--+++++ WML / WAP  +++++-->
                <xsl:otherwise>
                    <xsl:choose>
                        <xsl:when test="not($outputType = 'WML')">
                            <xsl:element name="a">
                                <xsl:attribute name="href"><xsl:value-of select="@xlink:href"/></xsl:attribute>
                                <xsl:call-template name="apply-styles-and-content">
                                    <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                                </xsl:call-template>
                            </xsl:element>
                        </xsl:when>
                        <xsl:otherwise>
                            <!-- no nested p tags in wml1.1 allowed -->
                            <xsl:choose>
                                <xsl:when test="ancestor::*[contains($wap-paragraph-elements, name())]">
                                    <xsl:call-template name="apply-styles-and-content">
                                        <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                                    </xsl:call-template>
                                </xsl:when>
                                <xsl:otherwise>
                                    <xsl:element name="p">
                                        <xsl:call-template name="apply-styles-and-content">
                                            <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                                        </xsl:call-template>
                                    </xsl:element>
                                </xsl:otherwise>
                            </xsl:choose>
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:if>
    </xsl:template>



    <xsl:template match="text:line-break">
        <xsl:element name="br"/>
    </xsl:template>


<!--
    TABHANDLING PROBLEM: Tabs are possible to be shown in the HTML text file, but will be later stripped as whitespaces.
        To prevent this one way would be the PRE tag which unfortunately ALWAYS result into a line-break. No surrounding NOBR tags help.

    <xsl:template match="text:tab-stop">
        <xsl:if test="not(preceding-sibling::text:tab-stop)">
            <xsl:element name="pre"><xsl:text>&#9;</xsl:text><xsl:for-each select="following-sibling::text:tab-stop"><xsl:text>&#9;</xsl:text></xsl:for-each></xsl:element>
        </xsl:if>
     </xsl:template>

    <xsl:template match="text:tab-stop"><xsl:text>&#9;</xsl:text></xsl:template>
-->
    <!-- HOTFIX: 8 non-breakable-spaces instead of a TAB is a hack sometimes less Tabs are needed and the code more difficult to read -->
    <xsl:template match="text:tab-stop"><xsl:text>  &#160; &#160; &#160; &#160; &#160; &#160; &#160; &#160;</xsl:text></xsl:template>


    <!-- currently there have to be an explicit call of the style attribute nodes, maybe the attributes nodes have no priority only order relevant-->
    <!-- STRANGE: checked with biorythm.sxc a simple xsl:apply-templates did not recognice the styles. Maybe caused by the template match order?  -->
    <xsl:template name="apply-styles-and-content">
        <xsl:param name="collectedGlobalData"/>

        <xsl:apply-templates select="@text:style-name | @draw:style-name | @draw:text-style-name | @table:style-name"><!-- | @presentation:style-name -->
            <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
        </xsl:apply-templates>

        <xsl:apply-templates>
            <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
        </xsl:apply-templates>
    </xsl:template>


    <xsl:template match="@text:style-name | @draw:style-name | @draw:text-style-name | @table:style-name"><!-- | @presentation:style-name-->
        <xsl:param name="collectedGlobalData"/>

        <xsl:choose>
            <!--+++++ CSS (CASCADING STLYE SHEET) HEADER STYLE WAY +++++-->
            <xsl:when test="$outputType = 'CSS_HEADER'">
                <xsl:attribute name="class"><xsl:value-of select="translate(., '. %()/\', '')"/></xsl:attribute>
            </xsl:when>

            <!--+++++ HTML 4.0 INLINED WAY  +++++-->
            <xsl:when test="$outputType = 'CSS_INLINED'">
                <xsl:attribute name="style"><xsl:value-of select="$collectedGlobalData/allstyles/*[name()=current()/.]"/></xsl:attribute>
            </xsl:when>

            <!--+++++ PALM 3.2 SUBSET INLINED WAY  and  WML / WAP   +++++-->
            <xsl:when test="$outputType = 'PALM' or $outputType = 'WML'">
                <!-- getting the css styles for the style name (mapped by style-mapping.xsl) -->
                <xsl:variable name="styleProperties" select="$collectedGlobalData/allstyles/*[name()=current()/.]"/>
                <!-- changing the context node -->
                <xsl:for-each select="parent::*">
                    <xsl:call-template name="create-nested-format-tags">
                        <xsl:with-param name="styleProperties" select="$styleProperties"/>
                        <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
                    </xsl:call-template>
                </xsl:for-each>
            </xsl:when>
        </xsl:choose>
    </xsl:template>


    <xsl:template match="text:sequence">
        <xsl:param name="collectedGlobalData"/>

        <xsl:apply-templates>
            <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
        </xsl:apply-templates>
    </xsl:template>



    <!-- ********************************************** -->
    <!-- *** Global Document -  Table of Content    *** -->
    <!-- ********************************************** -->


    <xsl:template match="text:table-of-content">
        <xsl:param name="collectedGlobalData"/>

        <xsl:apply-templates>
            <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
        </xsl:apply-templates>
    </xsl:template>

    <xsl:template match="text:index-body">
        <xsl:param name="collectedGlobalData"/>

        <xsl:apply-templates>
            <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
        </xsl:apply-templates>
    </xsl:template>


    <xsl:template match="text:index-title">
        <xsl:param name="collectedGlobalData"/>

        <xsl:apply-templates>
            <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
        </xsl:apply-templates>
    </xsl:template>



    <xsl:template name="transform-global-document-children">
        <xsl:param name="collectedGlobalData"/>
        <xsl:choose>
            <xsl:when test="$collectedGlobalData/contentTable">
                <xsl:call-template name="start-child-transformation">
                    <xsl:with-param name="collectedGlobalData"   select="$collectedGlobalData"/>
                </xsl:call-template>
            </xsl:when>
            <xsl:otherwise>

                <!-- The necessary auxiliary variable hasn't build yet.
                This variable gonna store all headers (possible anchor positions) and the URL of their files -->
                <xsl:variable name="documentDependencies-RTF">
                    <xsl:call-template name="add-content-table-global-data">
                        <xsl:with-param name="collectedGlobalData"   select="$collectedGlobalData"/>
                    </xsl:call-template>
                </xsl:variable>
                <xsl:choose>
                    <xsl:when test="function-available('xt:node-set')">
                        <xsl:call-template name="start-self-and-child-transformation">
                            <xsl:with-param name="collectedGlobalData"   select="xt:node-set($documentDependencies-RTF)"/>
                        </xsl:call-template>
                    </xsl:when>
                    <xsl:when test="function-available('xalan:nodeset')">
                        <xsl:call-template name="start-self-and-child-transformation">
                            <xsl:with-param name="collectedGlobalData" select="xalan:nodeset($documentDependencies-RTF)"/>
                        </xsl:call-template>
                    </xsl:when>
                </xsl:choose>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>

	<xsl:template name="start-self-and-child-transformation">
        <xsl:param name="collectedGlobalData"/>

        <xsl:apply-templates>
            <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
        </xsl:apply-templates>


        <xsl:call-template name="start-child-transformation">
            <xsl:with-param name="collectedGlobalData" select="$collectedGlobalData"/>
        </xsl:call-template>

	</xsl:template>

    <xsl:template name="start-child-transformation">
        <xsl:param name="collectedGlobalData"/>

        <!-- As the childdocuments of a global document (with suffix .sxg) do not know anything about their global parent,
            the transformation of global documents children have to be done implizit.
            Otherwise the chapter number of the children will always start with zero, as they do not know anything about the
            proceding chapters.
            Furthermore, they don't have any links about preceeding and following documents and no linking for usability reasons
            could be done. Therefore the children have to be transformed during the transformation of a global (sxg) document -->
		<xsl:if test="$DEBUG">
            <xsl:choose>
                <xsl:when test="$collectedGlobalData/contentTable">
                    <xsl:message>Contentable data exists as global data!</xsl:message>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:message>No Contentable global data exists!</xsl:message>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:if>

        <xsl:choose>
            <xsl:when test="function-available('sxghelper:transform-children')">
                <xsl:message>
                    <xsl:value-of select="sxghelper:transform-children( $collectedGlobalData,
                                                                        $jaredRootURL,
                                                                        $absoluteSourceDirRef,
                                                                        $optionalURLSuffix,
                                                                        $dpi,
                                                                        $outputType,
                                                                        $DEBUG)"/>
                </xsl:message>
            </xsl:when>
            <xsl:otherwise>
                <xsl:message>Java method transformChildren to transform all children of a global document could not be found. Be sure to use the XT processor.</xsl:message>
            </xsl:otherwise>
        </xsl:choose>


    </xsl:template>



</xsl:stylesheet>
