rem Transforms OpenOffice XML documents to HTML
rem
rem This batch does a transformation of an OpenOffice document to HTML (or WML, PALM HTML - cp. outputType parameter).
rem The OpenOffice file input can be uncompressed, in the flat XML format or as JAR URL (cp. sx2html.bat).
rem All further parameters will be explained in the first stylesheet main_html.xsl (or for WML main_wml.xsl).
cls
@echo off
set CLASSORIG=%CLASSPATH%

rem NOTICE! -> adapt the directory of the Xalan parser,get the binary from http://xml.apache.org/dist/xalan-j/
set XALAN_DIR=..\xalan-j_20020801\bin

rem NOTICE! -> adapt the directory of the XT processor, get the binary from http://www.blnz.com/xt/index.html
set XT_DIR=..\xt-20020426a

set CLASSPATH=%CLASSPATH%;%XALAN_DIR%\xercesImpl.jar;%XALAN_DIR%\xml-apis.jar;%XT_DIR%\xt.jar;
set PARSER=org.xml.sax.helpers.XMLReaderAdapter
set DRIVER=org.apache.xerces.parsers.SAXParser

rem * An absolute destination path is then necessary, if the source is a SXG (global document) containing links to child documents.
rem * Such a child document will be implizit transformed via a java call to SxgChildTransformer.
rem * For Usability reasons the child output gonna get HTML links to the ContentTable.
rem * In case it the child resists in a different directory as the global document, that link won't work.
set ABSOLUTE_SOURCE_DIR_PATH=\xsltTest\testfiles\testfile
set DESTINATION_FILE_NAME=xt-out.htm

@echo on
java -cp %CLASSPATH% -Dcom.jclark.xsl.sax.parser=%PARSER% -Dorg.xml.sax.driver=%DRIVER% com.jclark.xsl.sax.Driver  %ABSOLUTE_SOURCE_DIR_PATH%\content.xml main_html.xsl %ABSOLUTE_SOURCE_DIR_PATH%\%DESTINATION_FILE_NAME%  absoluteSourceDirRef=%ABSOLUTE_SOURCE_DIR_PATH%/ jaredRootURL=%ABSOLUTE_SOURCE_DIR_PATH%/ metaFileURL=%ABSOLUTE_SOURCE_DIR_PATH%\meta.xml stylesFileURL=%ABSOLUTE_SOURCE_DIR_PATH%\styles.xml tableOfContentDocumentURL=%ABSOLUTE_SOURCE_DIR_PATH%/%DESTINATION_FILE_NAME%
@echo off
set CLASSPATH=%CLASSORIG%

